jQuery(document).ready(function(){
	
	$("#y42SeguimientoSearch_avisos").rup_feedback({
		type:"ok",
		delay:800,
		gotoTop : false,
		block : false,
		closeLink : true
	});

	pintarFecha();
		
	//Bloque de acciones sobre el segundo grid	
	$("#y42SeguimientoItemGrid").click(function(){
		$("#y42SeguimientoItemGrid").rup_grid("reloadGrid");
		$("#y42SeguimientoItemGrid").rup_grid("clearGridData");
	});
	
	$("#y42bSeguimientoCleanDateAfter").click(function () {
        $("#y42SeguimientoDateAfter").val("");
        $("#y42SeguimientoBefore").rup_date("destroy"); //destruir la parte del hasta
        pintarFecha(); //repintar
    });
	
	$("#y42bSeguimientoCleanDateBefore").click(function () {
        $("#y42SeguimientoBefore").val("");
        $("#y42SeguimientoDateAfter").rup_date("destroy"); //destruir la parte del hasta
        pintarFecha(); //repintar
    });
			
	
	
	var ResultGridWidth = $("#workarea").width()- 50;
	
	//FIXME Migracion UDA V.2.4.4 (201504) - Quitamos el POST y añadimos el fluidBaseLayer
	$("#y42SeguimientoItemGrid").rup_grid({
		url:"/y42bVistaWar/item",
		pagerName: "contact_pager_item",
		rowNum: "10",
		sortorder: "desc",
		sortname: "nombre",
		//caption: "Envíos",
		loadOnStartUp: false,
		Editable:false,
		fluidBaseLayer:"y42SeguimientoItemGridDiv",		
		colNames:[
			$.rup.i18n.app.envSegItem_grid.envioId,
			$.rup.i18n.app.envSegItem_grid.itemtRef,
			$.rup.i18n.app.envSegItem_grid.mailingResponseCode,
			$.rup.i18n.app.envSegItem_grid.seleccionado,
			$.rup.i18n.app.envSegItem_grid.fechaLectura,
			$.rup.i18n.app.envSegItem_grid.entidad,
			$.rup.i18n.app.envSegItem_grid.nombre
		],
		colModel:[
			{
				name: "envioEnvioId",
				index: "envioEnvioId",
				hidden: true,
				sortable: false
			},
			{
				name: "itemRef",
				index: "itemRef",
				width: funcPercentage(10,ResultGridWidth),
				hidden: true,
				sortable: false
			},
			{  
				name:"mailingResponseCode",
				index:"mailingResponseCode",
				width: funcPercentage(10,ResultGridWidth),
				hidden:false,
				formatter:cambiaImagenMailing,
				sortable: false
			},
			{
				name: "seleccionado",
				index: "seleccionado",				
				width: funcPercentage(10,ResultGridWidth),	
				formatter:cambiaImagen,
				sortable: false				
			},
//			{
//				name: "fechaMailingRecepcion",
//				index: "fechaMailingRecepcion",
//				width: funcPercentage(20,ResultGridWidth),
//				align: "center",
//				formatter:cambiaImagen,
//				sortable: false	
//			},
			{
				name: "fechaMailingRecepcion",
				index: "fechaMailingRecepcion",
				width: funcPercentage(20,ResultGridWidth),
				align: "center",
				sortable: false	
			},
			{
				name: "itemRef",
				index: "itemRef",
				width: funcPercentage(10,ResultGridWidth),
				hidden: false,
				formatter: ponIcono,
				sortable: false
			},
			{
				name: "nombre",
				index: "nombre",
				width: funcPercentage(50,ResultGridWidth),
				align: "center",
				formatter:cambiaColor,
				sortable: false
			}
		]

	});
	
	//FIXME Migracion UDA V.2.4.4 (201504) - Quitamos el POST y añadimos el fluidBaseLayer
	$("#y42SeguimientoSearchResultGrid").rup_grid({	
		url:"/y42bVistaWar/envio/segui",
		pagerName: "contact_pager_envio",
		rowNum: "10",
		sortorder: "desc",
		sortname: "fechaOperacion",
		//caption: "Destinatario de envío",		
		loadOnStartUp: false,
		fluidBaseLayer:"y42SeguimientoSearchResultGridDiv",		
		colNames:[
			$.rup.i18n.app.envSeg_grid.envioId,
			$.rup.i18n.app.envSeg_grid.mailingAsunto,
			$.rup.i18n.app.envSeg_grid.fechaOperacion,
			$.rup.i18n.app.envSeg_grid.totalEnvios,
			$.rup.i18n.app.envSeg_grid.numContactos,
			$.rup.i18n.app.envSeg_grid.numEntidades,
			$.rup.i18n.app.envSeg_grid.numTotal,
			$.rup.i18n.app.envSeg_grid.seleccionadosConEmail,
			$.rup.i18n.app.envSeg_grid.enviadosOK,
			$.rup.i18n.app.envSeg_grid.totalEnviosLeidos
		],
		colModel:[
			{
				name: "envioId",
				index: "envioId",
				hidden: true,
				sortable: false
			},
			{
				name: "mailingAsunto",
				index: "mailingAsunto",
				width: funcPercentage(24,ResultGridWidth),
				align: "center",
				sortable: false	
			},
			{
				name: "fechaOperacion",
				index: "fechaOperacion",
				width: funcPercentage(15,ResultGridWidth),
				align: "center",
				sortable: false
			},
			{
				name: "totalEnvios",
				index: "totalEnvios",
				width: funcPercentage(15,ResultGridWidth),
				align: "center",
				hidden: true,
				sortable: false
			},
			{
				name: "totalContactos",
				index: "totalContactos",
				width: funcPercentage(10,ResultGridWidth),
				align: "center",
				sortable: false
			},
			{
				name: "totalEntidades",
				index: "totalEntidades",
				width: funcPercentage(10,ResultGridWidth),
				align: "center",
				sortable: false
			},
			{
				name: "total",
				index: "total",
				width: funcPercentage(10,ResultGridWidth),
				align: "center",
				sortable: false
			},
			{
				name: "seleccionadosConEmail",
				index: "seleccionadosConEmail",
				width: funcPercentage(10,ResultGridWidth),
				align: "center",
				sortable: false
			},
			{
				name: "totalEnviadosOK",
				index: "totalEnviadosOK",
				width: funcPercentage(10,ResultGridWidth),
				align: "center",
				sortable: false
			},
			{
				name: "totalEnviosLeidos",
				index: "totalEnviosLeidos",
				width: funcPercentage(10,ResultGridWidth),
				align: "center",
				sortable: false
			}
			
			
		],
		onSelectRow : function(ID,selectR) {						
			var row = $("#y42SeguimientoSearchResultGrid").rup_grid("getRowData", ID);			
			var url="/y42bVistaWar/item?envioEnvioId=" + row.envioId+"&seleccionado=S";
			$("#y42SeguimientoItemGrid").rup_grid("clearGridData");
			$("#y42SeguimientoItemGrid").rup_grid("setGridParam", {url : url});
			$("#y42SeguimientoItemGrid").rup_grid("reloadGrid");
		}		  	 					
	});
	
	bindActionButtons();
});

function pintarFecha(){
    $.rup_date({
        from : "y42SeguimientoDateAfter",
        to : "y42SeguimientoBefore",
        duration : "fast"
    });
    
    $("y42SeguimientoBefore").val("");
    
    
}

function search() {
	$("#y42SeguimientoItemGrid").rup_grid("clearGridData");
	$("#y42SeguimientoSearchResultGrid").rup_grid("clearGridData");
	var query = $("#y42SeguimientoSearchForm").serialize();	
	//alert($("#y42SeguimientoSearchResultGrid").rup_grid("getGridParam", "url"));
	$("#y42SeguimientoSearchResultGrid").rup_grid("setGridParam", {url : "/y42bVistaWar/envio/segui?" + query});
	//alert ('query'+query);
	$("#y42SeguimientoSearchResultGrid").rup_grid("reloadGrid");	
}

function cleanDate(){
	$("#y42SeguimientoDateAfter").rup_date("setDate", "");
	$("#y42SeguimientoBefore").rup_date("setDate", "");
}

function bindActionButtons(){	
	$("#y42SeguimientoSearchButton").click(function(){
		search();
	});
	
	$("#y42SeguimientoCleanButton").click(function(){
		cleanSearch();
	});
	
	$("#y42SeguimientoDeleteButton").click(function(){
		var row = $("#y42SeguimientoSearchResultGrid").rup_grid("getRowData",$("#y42SeguimientoSearchResultGrid").rup_grid("getSelectedRows")[0]);
		if(null!=row.envioId) {
			   $.rup_messages("msgConfirm",{
				   title:$.rup.i18n.app.comun.confirmacion,
				   message: $.rup.i18n.app.msg.confirmacioneliminarseguimiento,
				   OKFunction : function () {
					   selectRow(row.envioId);
					}
			   });
		}
	});
}

function selectRow(envioId){
	//alert("envioId"+envioId);
	$.ajax({
	    type: "DELETE",
	    url: "/y42bVistaWar/envio/" + envioId,
	    error: function (jqXHR, textStatus, errorThrown){
				$("#y42SeguimientoSearch_avisos").rup_feedback("option", "delay",null);
				$("#y42SeguimientoSearch_avisos").rup_feedback("set",jqXHR.responseText, "error");
		},
		success : function(data) {
					$("#y42SeguimientoSearchResultGrid").rup_grid("reloadGrid");
					$("#y42SeguimientoItemGrid").rup_grid("clearGridData");
		}
	});
}

function cleanSearch(){
	$("#y42SeguimientoEnvioAsunto").val("");
	
    $("#y42SeguimientoDateAfter").val("");
    $("#y42SeguimientoBefore").rup_date("destroy"); //destruir la parte del hasta
    pintarFecha(); //repintar
    
    $("#y42SeguimientoBefore").val("");
    $("#y42SeguimientoDateAfter").rup_date("destroy"); //destruir la parte del hasta
    pintarFecha(); //repintar
	
	$("#y42SeguimientoSearchResultGrid").rup_grid("clearGridData");
	$("#y42SeguimientoItemGrid").rup_grid("clearGridData");
}

//funcion para mostrar el tick(ok)o tick(error),si tiene fecha lectura o no respectivamente
function cambiaImagen(cellValue, options, rowObject) {
	var staticUrl=$("#idStaticsPath").val();
	var col=rowObject.fechaMailingRecepcion; 
	
    if (col == null)
    	return '<P ALIGN="center"><img src="'+staticUrl+'/y42b/images/tick_rojo.JPG"  width="16" height="16"></P>';
    else 
    	return '<P ALIGN="center"><img src="'+staticUrl+'/y42b/images/tick_verde.JPG"  width="16" height="16"></P>';
}
//funcion que cambia a rojo el color del campo asunto en funcion del codigo de la columna code(oculta al usuario)
function cambiaColor(cellvalue, options, rowObject) {	
	var color="black";
	
	var col=rowObject.mailingResponseCode; 
	if ( col=='ERROR' ) { var color ="red";}

	var cellHtml = "<span style='color:" + color + "' originalValue='" +
	cellvalue + "'>" + cellvalue + "</span>";
	return cellHtml;
}



//funcion que cambia a rojo el color del campo asunto en funcion del codigo de la columna code(oculta al usuario)
function ponIcono(cellvalue, options, rowObject) {	
	var staticUrl=$("#idStaticsPath").val();
	if (cellvalue.substring(0,1)=="E"){
		return '<P ALIGN="center"><img src="'+staticUrl+'/y42b/images/entidad.png"  width="16" height="16"></P>';
	}else if (cellvalue.substring(0,1)=="C"){
		return '<P ALIGN="center"><img src="'+staticUrl+'/y42b/images/contacto.png"  width="16" height="16"></P>';
	}else{
		return '';
	}

}




$("#y42SeguimientoVerMensaje").click(function(){
	var row = $("#y42SeguimientoSearchResultGrid").rup_grid("getRowData",$("#y42SeguimientoSearchResultGrid").rup_grid("getSelectedRows")[0]);
	
	if (null!=row.envioId && ""!=row.envioId) {
		y42bVarEnvioId = row.envioId;

		y42bVarDeEnvio = true;
		$("#envioSendEmailDialog").rup_dialog("destroy");
		$("#envioSendEmailDialog").rup_dialog({
			height: "auto",
			resizable: false,
		    width: 850,
			modal: true,
			url: "../search/sendMail/"+y42bVarEnvioId,
			type:$.rup.dialog.AJAX,
			title: $.rup.i18n.app.popup.consultamail,
			autoOpen: true,
			close: function(event, ui) {
//				$("#envioSendEmailDialog").remove();
//				$("#envioSendEmailDialog").prepend('<div id="envioSendEmailDialog">');
			}
		});
	}else{
		$("#y42SeguimientoSearch_avisos").rup_feedback("option", "delay", 2000);
		$("#y42SeguimientoSearch_avisos").rup_feedback("set",$.rup.i18n.app.msg.seleccioneEnvio, "alert");
	}
});



//funcion para mostrar el tick(ok)o tick(error),si tiene fecha lectura o no respectivamente
function cambiaImagenMailing(cellValue, options, rowObject) {
	var staticUrl=$("#idStaticsPath").val();
	var col=rowObject.mailingResponseCode; 
	
    if (col == null)
    	return '<P ALIGN="center"><img src="'+staticUrl+'/y42b/images/tick_rojo.JPG"  width="16" height="16"></P>';
    else 
    	return '<P ALIGN="center"><img src="'+staticUrl+'/y42b/images/tick_verde.JPG"  width="16" height="16"></P>';
}

